.286c
jumps
locals @@

include se.asm

TWEAK = 1

idle    equ jmp short $+2

data    segment word public
        extrn Result:dword, SB:dword, MB:dword, FB:dword
        extrn SegA000:word, ModeX:byte
data    ends

code    segment byte public
        assume cs:code, ds:data
        public DrawScreen, DrawSprite, UpdateScreen
        public SetMode, Tekstit

.386c

;Procedure DrawScreen;
DrawScreen:
        les di, Result
        mov dx, ds
        mov bx, di
         lds si, SB     ;1st phase: Background
         cld
         mov ecx, 16000
         rep movsd
        mov di, bx
        mov ds, dx
         lds si, MB     ;2nd phase: The game
         mov cx, 64000
@@0:     mov al, [si]
         inc si
         cmp al, 255
         je @@1
         mov es:[di], al
@@1:     inc di
         dec cx
         jnz @@0
        mov di, bx
        mov ds, dx
         lds si, FB     ;3rd phase: Foreground
         mov cx, 64000
@@2:     mov al, [si]
         inc si
         cmp al, 255
         je @@3
         mov es:[di], al
@@3:     inc di
         dec cx
         jnz @@2
        mov ds, dx
        retn

;Procedure SetMode;
SetMode:mov ax, 13h
        int 10h

    IF TWEAK
        mov ax, 0604h
        mov dx, 3C4h
        out dx, ax
        idle
        mov ax, 0100h
        out dx, ax
        idle
        mov dx, 3C2h
        mov al, 0E3h
        out dx, al
        idle
        mov ax, 0300h
        mov dx, 3C4h
        out dx, ax
        idle
        mov dx, 3D4h
        mov al, 11h
        out dx, al
        inc dx
        in al, dx
        and al, 7Fh
        out dx, al
        dec dx
        idle

        ;mov ax, 4009h   ;Uncomment this if you
        ;out dx, ax      ;want "high" resolution

        ;mov ax, 4B01h
        ;out dx, ax
        ;mov ax, 0002h
        ;out dx, ax
        ;mov ax, 0103h
        ;out dx, ax
        ;mov ax, 0005h
        ;out dx, ax
        mov ax, 0D06h
        out dx, ax
        mov ax, 3E07h
        out dx, ax
        mov ax, 0EA10h
        out dx, ax
        mov ax, 0AC11h
        out dx, ax
        mov ax, 0DF12h
        out dx, ax
        mov ax, 0E715h
        out dx, ax
        mov ax, 0616h
        out dx, ax

        mov ax, 0014h
        out dx, ax
        mov ax, 0E317h
        out dx, ax

        mov al, 13h
        out dx, al
        mov al, 320/8
        inc dx
        out dx, al

        mov Modex, 1
    ENDIF
        retn

;Procedure UpdateScreen;
UpdateScreen:
        mov es, SegA000

        lfs si, Result ;Move this all to screen
    IF TWEAK
        mov bx, si

        mov dx, 3C4h

        mov ax, 0102h
        out dx, ax
        xor di, di
        mov cx, 4000
        lea si, [bx-4]
@@0:  rept 4
        add si, 4
        mov al, fs:[si]
        ror eax, 8
      endm
        mov es:[di], eax
        add di, 4
        dec cx
        jnz @@0

        mov ax, 0202h
        out dx, ax
        xor di, di
        mov cx, 4000
        lea si, [bx-3]
@@1:  rept 4
        add si, 4
        mov al, fs:[si]
        ror eax, 8
      endm
        mov es:[di], eax
        add di, 4
        dec cx
        jnz @@1

        mov ax, 0402h
        out dx, ax
        xor di, di
        mov cx, 4000
        lea si, [bx-2]
@@2:  rept 4
        add si, 4
        mov al, fs:[si]
        ror eax, 8
      endm
        mov es:[di], eax
        add di, 4
        dec cx
        jnz @@2

        mov ax, 0802h
        out dx, ax
        xor di, di
        mov cx, 4000
        lea si, [bx-1]
@@3:  rept 4
        add si, 4
        mov al, fs:[si]
        ror eax, 8
      endm
        mov es:[di], eax
        add di, 4
        dec cx
        jnz @@3
    ELSE
        xor di, di
        mov cx, 16000
        cld
        rep segfs movsd
    ENDIF
        retn

;Procedure DrawSprite(Dest, Src: PChar;
;                     x, y: Word;
;                     Flip: Boolean;
;                     PictXSize, PictYSize: Word);
DrawSprite:
        arg Dest, dword, 1
        arg Src, dword, 1
        arg x, word, 1
        arg y, word, 1
        arg Flip, byte, 2
        arg PictXSize, word, 1
        arg PictYSize, word, 1
        entry near

        les di, Dest
        mov ax, 320
        mul y
        add ax, x
        add di, ax

        push ds

        lds si, Src

        mov cx, PictYSize

        mov dx, y
        or dx, dx
        js @@1
        xor dx, dx
        jmp @@9
@@1:    neg dx

@@9:    mov al, Flip
        or al, al
        jz @@2

        add di, PictXSize
        dec di
@@5:    mov bx, cx
         mov cx, PictXSize
@@6:     mov al, [si]
         cmp al, 255
         je @@7
         or dx, dx
         jnz @@7
         mov es:[di], al
@@7:     inc si
         dec di
         dec cx
         jnz @@6
        mov cx, bx
        add di, 320
        add di, PictXSize
        or dx, dx
        jz @@10
        dec dx
@@10:   dec cx
        jnz @@5
        jmp @@4

@@2:    mov bx, cx
         mov cx, PictXSize
@@3:     mov al, [si]
         cmp al, 255
         je @@8
         or dx, dx
         jnz @@8
         mov es:[di], al
@@8:     inc si
         inc di
         dec cx
         jnz @@3
        mov cx, bx
        add di, 320
        sub di, PictXSize
        or dx, dx
        jz @@11
        dec dx
@@11:   dec cx
        jnz @@2
@@4:    pop ds

        exit

Tekstit:db 10
;        db 'EXA DEMO REVISION 2 B 23.1.1997 22:30',10
        db 'EXA DEMO REVISION 2 C 19.3.1997 10:08',10
        db 10
        db 'This program demonstrates animation.',10
        db 10
        db 'This program uses:',10
        db 'Borland Pascal with Objects v7.0',10
        db 'Midas Sound System v0.40A',10
        db 10
        db 'Program made by:',10
        db 'Bisqwit of TCS and Reflex',10
        db 10
        db 'Copyright:',10
        db 'This program is learnware.',10
        db 'No payment is allowed.',10
        db 'The copyrights to the music',10
        db 'belong to CapCom co.,ltd.',10
        db 'Music has been transformed to',10
        db 'module by Bisqwit.',10
        db 'Font copyright by IBM, I guess',10
        db 10
        db 'Remarks:',10
        db 'This engine has been used',10
        db 'in the Exa Man game.',10
        db 10
        db 'Repetitio mater studiorum est:',10
        db 10
        db 0

code    ends

.286c

end
