{$F-,I-,O+}
unit System;

{ This unit implements Turbo Pascal's runtime library. When compiling
  this unit, the compiler automatically includes a boot-strap symbol
  table (SYSTEM.TPS) which declares all built-in types, procedures, and
  functions. }

{$IFDEF DPMI}
 {$C FIXED PRELOAD PERMANENT}
 {$DEFINE LYHYT}
{$ENDIF}

{$IFDEF WINDOWS}
 {$C MOVEABLE PRELOAD PERMANENT}
{$ENDIF}

{$IFDEF MSDOS}
 {$L SYS_MAIN.OBJ}           { Main module }
 {$L SYS_HEAP.OBJ}           { Heap manager }
 {$L SYS_ERRC.OBJ}           { Error check routines }
 {$L SYS_EI86.OBJ}           { Software emulator initialization }
 {$L SYS_EI87.OBJ}           { Hardware emulator initialization }
 {$L SYS_EM86.OBJ}           { Software 80x87 emulator }
 {$L SYS_EM87.OBJ}           { Hardware 80x87 emulator }
 {$L SYS_F87H.OBJ}           { 80x87 support routines }
{$ENDIF}

{$IFDEF DPMI}
 {$L SYS_DAPP.OBP}           { DPMI application main module }
 {$L SYS_DLIB.OBP}           { DPMI library main module }
 {$L SYS_DEND.OBP}           { DPMI termination procedures }
 {$L SYS_WMEM.OBP}           { DPMI heap manager }
 {$L SYS_ERRC.OBP}           { Error check routines }
 {$L SYS_EI86.OBP}           { Software emulator initialization }
 {$L SYS_EI87.OBP}           { Hardware emulator initialization }
 {$L SYS_EM86.OBP}           { Software 80x87 emulator }
 {$L SYS_EM87.OBP}           { Hardware 80x87 emulator }
 {$L SYS_F87H.OBP}           { 80x87 support routines }
{$ENDIF}

{$IFNDEF Windows}
 {$L SYS_OBJH.OBJ}           { Object handling routines }
 {$L SYS_DF87.OBJ}           { 80x87 Binary/Decimal routines }
 {$IFNDEF NOSTDIO}
  {$L SYS_TCTL.OBJ}           { Textfile control routines }
  {$L SYS_TGPC.OBJ}           { Textfile low-level I/O }
  {$L SYS_TCHR.OBJ}           { Textfile character I/O }
  {$L SYS_TPCH.OBJ}           { Textfile character array I/O}
  {$L SYS_TSTR.OBJ}           { Textfile string I/O }
  {$L SYS_TBOL.OBJ}           { Textfile boolean I/O }
  {$L SYS_TINT.OBJ}           { Textfile integer I/O }
  {$L SYS_TF48.OBJ}           { Textfile real I/O }
  {$L SYS_TF87.OBJ}           { Textfile 80x87 I/O }
  {$L SYS_TFUN.OBJ}           { Textfile support functions }
  {$L SYS_FCTL.OBJ}           { File control routines }
  {$L SYS_FDIR.OBJ}           { File utility routines }
 {$ENDIF}
 {$L SYS_CINT.OBJ}           { Integer Str/Val routines }
 {$L SYS_CF48.OBJ}           { Real Str/Val routines }
 {$L SYS_CF87.OBJ}           { 80x87 Str/Val routines }
 {$L SYS_PARS.OBJ}           { Command line parameter routines }
 {$L SYS_DIRH.OBJ}           { Directory handling routines }
{$ELSE}
 {$L SYS_WAPP.OBW}           { Windows application main module }
 {$L SYS_WLIB.OBW}           { Windows library main module }
 {$L SYS_WEND.OBW}           { Windows termination procedures }
 {$L SYS_WMEM.OBW}           { Windows heap manager }
 {$L SYS_ERRC.OBW}           { Error check routines }
 {$L SYS_OBJH.OBW}           { Object handling routines }
 {$L SYS_DF87.OBW}           { 80x87 Binary/Decimal routines }
 {$IFNDEF NOSTDIO}
  {$L SYS_TCTL.OBW}           { Textfile control routines }
  {$L SYS_TGPC.OBW}           { Textfile low-level I/O }
  {$L SYS_TCHR.OBW}           { Textfile character I/O }
  {$L SYS_TSTR.OBW}           { Textfile string I/O }
  {$L SYS_TPCH.OBW}           { Textfile character array I/O}
  {$L SYS_TBOL.OBW}           { Textfile boolean I/O }
  {$L SYS_TINT.OBW}           { Textfile integer I/O }
  {$L SYS_TF48.OBW}           { Textfile real I/O }
  {$L SYS_TF87.OBW}           { Textfile 80x87 I/O }
  {$L SYS_TFUN.OBW}           { Textfile support functions }
  {$L SYS_FCTL.OBW}           { File control routines }
  {$L SYS_FDIR.OBW}           { File utility routines }
 {$ENDIF}
 {$L SYS_CINT.OBW}           { Integer Str/Val routines }
 {$L SYS_CF48.OBW}           { Real Str/Val routines }
 {$L SYS_CF87.OBW}           { 80x87 Str/Val routines }
 {$L SYS_WPAR.OBW}           { Command line parameter routines }
 {$L SYS_DIRH.OBW}           { Directory handling routines }
 {$L SYS_WI87.OBW}           { 80x87 initialization }
 {$L SYS_WX87.OBW}           { 80x87 exception handler }
 {$L SYS_WE87.OBW}           { 80x87 support routines }
 {$L SYS_WF87.OBJ}           { 80x87 transcendental routines }
{$ENDIF}

{$L SYS_VARH.OBJ}           { Variable support routines }
{$L SYS_LONG.OBJ}           { Longint arithmetic routines }
{$L SYS_LOVF.OBJ}           { Longint arith with overflow checks }
{$L SYS_STRH.OBJ}           { String support routines }
{$L SYS_SETH.OBJ}           { Set support routines }
{$IFNDEF NOSTDIO}
 {$L SYS_TFIO.OBJ}           { Textfile open routine }
{$ENDIF}
{$L SYS_FP48.OBJ}           { Real kernel routines }
{$L SYS_F48H.OBJ}           { Real support routines }
{$L SYS_F48F.OBJ}           { Real standard functions }
{$L SYS_RAND.OBJ}           { Random number generator }
{$L SYS_DINT.OBJ}           { Integer Binary/Decimal routines }
{$L SYS_DF48.OBJ}           { Real Binary/Decimal routines }
{$L SYS_SINT.OBJ}           { Integer Str/Val routines }
{$L SYS_SF48.OBJ}           { Real Str/Val routines }
{$L SYS_SF87.OBJ}           { 80x87 Str/Val routines }
{$IFNDEF NOSTDIO}
 {$L SYS_FFUN.OBJ}           { File support functions }
{$ENDIF}
{$L SYS_MEMH.OBJ}           { Block move and fill routines }
{$L SYS_CHAR.OBJ}           { Character handling routines }
{$L SYS_DMTH.OBJ}           { Dynamic method call dispatcher }

{$IFDEF MSDOS}
 {$IFDEF LYHYT}
  {$L SYS_VIIM.OBJ}           { Data segment initialization }
 {$ELSE}
  {$L SYS_LAST.OBJ}           { Data segment initialization }
 {$ENDIF}
{$ENDIF}

{$L sys_parm.obj}

interface

{ Initialized public variables. The compiler depends upon the order
  of declaration of the following typed constants, so it must not be
  changed. In addition, the following declaration section must be the
  first "const" section in this unit. }

procedure InitTurbo;
procedure HaltError;
procedure HaltTurbo;
procedure BlockMove;
procedure LongMul;
procedure LongDiv;
procedure LongShr;
procedure LongShl;
procedure LongMulOvf;
procedure Overflow;
procedure SLoad;
procedure SStore;
procedure RangeError;
procedure SCopy;
procedure SConcat;
procedure SPos;
procedure SCompare;
procedure SChar;
procedure SPacked;
procedure SInsert;
procedure SDelete;
procedure ZLoad;
procedure ZStore;
procedure ZBitMask;
procedure FTrunc;
procedure FRound;
procedure FInt;
procedure FSqrt;
procedure FSin;
procedure FCos;
procedure FArcTan;
procedure FLn;
procedure FExp;
procedure NewPtr;
procedure DisposePtr;
procedure MarkPtr;
procedure ReleasePtr;
procedure GetFreMem;
procedure GetFreMax;
procedure ZWordLoad;
procedure ZAddComp;
procedure ZAddRange;
procedure ZUnion;
procedure ZDifference;
procedure ZIntersect;
procedure ZEqual;
procedure ZRelation;
procedure GetParCnt;
procedure GetIORes;
procedure InOutCheck;
procedure RangeCheck;
procedure StackCheck;
procedure WriteFloat;
procedure WriteStr;
procedure WriteInt;
procedure WriteBool;
procedure WriteChar;
procedure WriteLine;
procedure WriteEnd;
procedure WriteFile;
procedure ReadFloat;
procedure ReadStr;
procedure ReadInt;
procedure ReadChar;
procedure ReadLine;
procedure ReadEnd;
procedure ReadFile;
procedure InitRand;
procedure AssignText;
procedure ResetText;
procedure RewriteText;
procedure CloseText;
procedure AssignFile;
procedure ResetFile;
procedure RewriteFile;
procedure CloseFile;
procedure EraseFile;
procedure RenameFile;
procedure GetSEoln;
procedure GetSEof;
procedure GetTEoln;
procedure GetTEof;
procedure ReadBlock;
procedure WriteBlock;
procedure SeekFile;
procedure GetFPos;
procedure GetFSize;
procedure GetFEof;
procedure FFrac;
procedure UpperCase;
procedure TruncFile;
procedure FillMem;
procedure RandInt;
procedure RandFloat;
procedure GetParStr;
procedure MoveMem;
procedure StrInt;
procedure ValInt;
procedure StrFloat;
procedure ValFloat;
procedure DirGet;
procedure DirSet;
procedure DirCreate;
procedure DirRemove;
procedure AppendText;
procedure FlushText;
procedure BufferText;
procedure FRealExt;
procedure FExtReal;
procedure RAdd;
procedure RSub;
procedure RMul;
procedure RDiv;
procedure RCmp;
procedure RFloat;
procedure RTrunc;
procedure RRound;
procedure RSqr;
procedure WriteReal;
procedure ReadReal;
procedure StrReal;
procedure ValReal;
procedure RInt;
procedure RFrac;
procedure RSqrt;
procedure RSin;
procedure RCos;
procedure RLn;
procedure RExp;
procedure RArcTan;
procedure RandReal;
procedure InitEM86;
procedure InitEM87;
procedure Construct;
procedure Destruct;
procedure CopyObject;
procedure MethodCheck;
procedure FindMethod;
procedure CallMethod;
procedure ReadPChar;
procedure WritePChar;
procedure AssignTextC;
procedure AssignFileC;
procedure RenameFileC;
procedure StrIntC;
procedure ValIntC;
procedure StrFloatC;
procedure ValFloatC;
procedure StrRealC;
procedure ValRealC;

procedure LibEntry;
procedure LibExit;
procedure LibExitProc;
{$IFDEF MSDOS}
 procedure InitTask;
{$ELSE}
 procedure InitTask; far;
{$ENDIF}

{ Uninitialized public variables. The compiler depends upon the order
  of declaration of the following variables, so it must not be changed.
  In addition, the following declaration section must be the first "Var"
  section in this unit. }
Var
{$IFNDEF NOSTDIO}
  Input: Text;                  { Input standard file }
  Output: Text;                 { Output standard file }
{$ENDIF}
  SaveInt00: Pointer;           { Saved exception $00 }
  SaveInt02: Pointer;           { Saved interrupt $02 }
  SaveInt06: Pointer;           { Saved exception $06 }
  SaveInt09: Pointer;           { Saved interrupt $09 }
  SaveInt0C: Pointer;           { Saved exception $0C }
  SaveInt0D: Pointer;           { Saved exception $0D }
  SaveInt1B: Pointer;           { Saved interrupt $1B }
  SaveInt21: Pointer;           { Saved interrupt $21 }
  SaveInt23: Pointer;           { Saved real mode interrupt $23 }
  SaveInt24: Pointer;           { Saved real mode interrupt $24 }
  SaveInt34: Pointer;           { Saved interrupt $34 }
  SaveInt35: Pointer;           { Saved interrupt $35 }
  SaveInt36: Pointer;           { Saved interrupt $36 }
  SaveInt37: Pointer;           { Saved interrupt $37 }
  SaveInt38: Pointer;           { Saved interrupt $38 }
  SaveInt39: Pointer;           { Saved interrupt $39 }
  SaveInt3A: Pointer;           { Saved interrupt $3A }
  SaveInt3B: Pointer;           { Saved interrupt $3B }
  SaveInt3C: Pointer;           { Saved interrupt $3C }
  SaveInt3D: Pointer;           { Saved interrupt $3D }
  SaveInt3E: Pointer;           { Saved interrupt $3E }
  SaveInt3F: Pointer;           { Saved interrupt $3F }
  SaveInt75: Pointer;           { Saved interrupt $75 }
{$IFDEF DPMI}
  RealModeRegs: array[0..49] of Byte; { Real mode call-back registers }
{$ENDIF}

{----------------------------------------------------------------------------}
{JA TNNE KAIKKI OMAT, _EI_YHTN_AIKASEMMIN_!!!!!!!!!!}
{----------------------------------------------------------------------------}
Procedure GetRunTimeError(Var s: String);
Procedure StdReportError;
Procedure StdTerminator;

{$IFDEF DPMI}
 procedure __AHIncr; far;
 procedure __0000H; far;
 procedure __0040H; far;
 procedure __A000H; far;
 procedure __B000H; far;
 procedure __B800H; far;
 procedure MEMallocateBlock; far;
 procedure MEMfreeBlock; far;
 procedure MEMqueryFreeMem; far;
 function MessageBox(WndParent: Word; Txt, Caption: PChar; TextType: Word): Integer; Far;
{$ENDIF}

{$IFDEF Windows}
 procedure LocalInit; far;
 procedure GlobalAlloc; far;
 procedure GlobalFree; far;
 procedure GlobalLock; far;
 procedure GlobalUnlock; far;
 procedure GlobalHandle; far;
 procedure GlobalCompact; far;
 procedure WaitEvent; far;
 procedure GetModuleFileName; far;
 procedure __AHIncr; far;
 procedure GetWinFlags; far;
 procedure GetFreeSpace;far;
 function MessageBox(WndParent: Word; Txt, Caption: PChar; TextType: Word): Integer; Far;
 procedure InitApp; far;
 procedure __FPMath; far;
 procedure AnsiToOem; far;
 procedure OemToAnsi; far;
{$ENDIF}

Const
{$IFDEF MSDOS}
  OvrCodeList: Word = 0;        { Overlay code segment list }
  OvrHeapSize: Word = 0;        { Initial overlay buffer size }
  OvrDebugPtr: Pointer = nil;   { Overlay debugger hook }
  OvrHeapOrg: Word = 0;         { Overlay buffer origin }
  OvrHeapPtr: Word = 0;         { Overlay buffer pointer }
  OvrHeapEnd: Word = 0;         { Overlay buffer end }
  OvrLoadList: Word = 0;        { Loaded overlays list }
  OvrDosHandle: Word = 0;       { Overlay DOS handle }
  OvrEmsHandle: Word = $FFFF;   { Overlay EMS handle }
  HeapOrg: Pointer = nil;       { Heap origin }
  HeapPtr: Pointer = nil;       { Heap pointer }
  HeapEnd: Pointer = nil;       { Heap end }
  FreeList: Pointer = nil;      { Free list pointer }
  FreeZero: Pointer = nil;      { Must be zero }
  HeapError: Function(Size: Word): Integer = nil;{ Heap error function }
  ExitProc: Procedure = nil;    { Exit procedure }
  ExitCode: Integer = 0;        { Exit code }
  ErrorAddr: Pointer = nil;     { Runtime error address }
  PrefixSeg: Word = 0;          { Program segment prefix }
  StackLimit: Word = 0;         { Stack pointer low limit }
  InOutRes: Integer = 0;        { I/O result buffer }
  RandSeed: Longint = 0;        { Random seed }
  SelectorInc: Word = $1000;    { Selector increment }
  Seg0000: Word = $0000;        { Selector for segment $0040 }
  Seg0040: Word = $0040;        { Selector for segment $0040 }
  SegA000: Word = $A000;        { Selector for segment $A000 }
  SegB000: Word = $B000;        { Selector for segment $B000 }
  SegB800: Word = $B800;        { Selector for segment $B800 }
  Test8086: Byte = 0;           { 80x86 test result }
  Test8087: Byte = 0;           { 80x87 test result }
  FileMode: Byte = 0;           { File open mode }
{$ENDIF}
{$IFDEF DPMI}
  HInstance: Word = 0;          { Module instance handle }
  HeapList: Word = 0;           { Heap segment list }
  HeapLimit: Word = 1024;       { Heap small block limit }
  HeapBlock: Word = 8192;       { Heap block size }
  HeapAllocFlags: Word = 2;     { Heap allocation flags, gmem_Moveable }
  HeapError: Function(Size: Word): Integer = nil;{ Heap error function }
  ExitProc: Procedure = nil;    { Exit procedure }
  ExitCode: Integer = 0;        { Exit code }
  ErrorAddr: Pointer = nil;     { Runtime error address }
  PrefixSeg: Word = 0;          { Program segment prefix }
  InOutRes: Integer = 0;        { I/O result buffer }
  RandSeed: Longint = 0;        { Random seed }
  SelectorInc: Word = 0;        { Selector increment }
  Seg0000: Word = 0;            { Selector for segment $0040 }
  Seg0040: Word = 0;            { Selector for segment $0040 }
  SegA000: Word = 0;            { Selector for segment $A000 }
  SegB000: Word = 0;            { Selector for segment $B000 }
  SegB800: Word = 0;            { Selector for segment $B800 }
  Test8086: Byte = 0;           { 80x86 test result }
  Test8087: Byte = 0;           { 80x87 test result }
  FileMode: Byte = 0;           { File open mode }
{$ENDIF}
{$IFDEF Windows}
  HPrevInst: Word = 0;          { Handle of previous instance }
  HInstance: Word = 0;          { Handle of this instance }
  CmdShow: Integer = 0;         { CmdShow parameter for CreateWindow }
  CmdLine: PChar = nil;         { Command line pointer }
  HeapList: Word = 0;           { Heap segment list }
  HeapLimit: Word = 1024;       { Heap small block limit }
  HeapBlock: Word = 8192;       { Heap block size }
  HeapAllocFlags: Word = 2;     { Heap allocation flags, gmem_Moveable }
  HeapError: Function(Size: Word): Integer = nil;{ Heap error function }
  ExitProc: Procedure = nil;    { Exit procedure }
  ExitCode: Integer = 0;        { Exit code }
  ErrorAddr: Pointer = nil;     { Runtime error address }
  PrefixSeg: Word = 0;          { Program segment prefix }
  InOutRes: Integer = 0;        { I/O result buffer }
  RandSeed: Longint = 0;        { Random seed }
  SelectorInc: Word = 0;        { Selector increment }
  Test8086: Byte = 0;           { 80x86 test result }
  FileMode: Byte = 0;           { File open mode }
{$ENDIF}

{LIS OMAT CONSTANTIT VASTA TMN JLKEEN!}
  SEEK_SET = 0;
  SEEK_CUR = 1;
  SEEK_END = 2;
{$IFNDEF NOSTDIO}
  BlankChar: Char = ' ';
  SeekMethod: Word = SEEK_SET;
{$ENDIF}
  ModeX: Boolean = False;
  GraphMode: Boolean = False;
  SetDriveAndPath: Boolean = True;
  Terminator: Procedure = StdTerminator;
  SysTermReportError: Procedure = StdReportError;

{$IFDEF MSDOS}
  SaveIntTab: String[23] = #0#2#6#9#$0C#$0D#$1B#$21#$23#$24#$34#$35#$36#$37#$38#$39#$3A#$3B#$3C#$3D#$3E#$3F#$75;
{$ENDIF}
{$IFDEF DPMI}
{ Saved interrupt and exception numbers. The first byte of each entry   }
{ is the low byte of the 02xxH DPMI function code to use when modifying }
{ the vector. 0 means real mode interrupt, 2 means protected mode       }
{ exception, and 4 means protected mode interrupt.                      }
  SaveIntTab: Array[0..8+8+7]Of Word =
 (8+8+7,
  $0002,$0204,$0602,$0902,$0C02,$0D02,$1B04,$2104,
  $2300,$2400,$3404,$3504,$3604,$3704,$3804,$3904,
  $3A04,$3B04,$3C04,$3D04,$3E04,$3F04,$7504);
{$ENDIF}

Type
  PtrRec   = Record Ofs,Seg: Word End;
  LongRec  = Record Lo, Hi: Word End;
  WordRec  = Record Lo, Hi: Byte End;
  PLongInt = ^LongInt;
  PInteger = ^Integer;
  PString  = ^String;
  PWord    = ^Word;
  PByte    = ^Byte;

Const
	RunErrorMessage: PChar = 'Runtime error %d at %04X:%04X'^M^J;

Function ParmStr(ParmStr: String; Index: Word): String;
Function ParmCount(ParmStr: String): Word;
Procedure FillWord(Var Dest; Count: Word; Data: Word);
Function SPFix(Var s: String): PString;
Function GetDrv: Char;
{$IFNDEF NOSTDIO}
 Function FSeek(Var f:File; NewPos:LongInt; Method:Word):LongInt;
 Function FGetCh(Var f: File): Char;
 Function FPutCh(Var f: File; Ch: Char): Char;
 Function ByteFileSize(Var t): LongInt;
{$ENDIF}
Function LoCase(c: Char): Char;

{ Longint routines }
Function SqrLong(X: Integer): Longint; Inline($58/$F7/$E8);
Function MulLong(X, Y: Integer): Longint; Inline($5A/$58/$F7/$EA);
Function DivLong(X: LongInt; Y: Integer): Integer; Inline($59/$58/$5A/$F7/$F9);
Function Min(X, Y: LongInt): LongInt;
Function Max(X, Y: LongInt): LongInt;
{$IFNDEF Windows}
Function Cmdline: PString;
{$ENDIF}

{$L FORMAT.OBJ}
Function FormatStr(var Result: String; const Format: String; var Params): PString;
Procedure SysTermGetExitAddress;
Procedure SysTermHandleExitProcs;
Procedure SysTermRestoreVectors;
Procedure DosTerminate;

Var
  ErrAddr: Pointer;

Implementation

{ The following external routines implement all Turbo Pascal standard
  procedures, functions, and operators. The compiler depends upon the
  order of declaration of these routines, so it must not be changed.
  In addition, these routines must be the first declared by this unit,
  so no procedures and functions can be declared in the interface part.
  The comment following each external directive specifies the .ASM
  module that contains the routine. }

procedure InitTurbo;            external {MAIN/DAPP/WAPP};
procedure HaltError;            external {MAIN/DEND/WEND};
procedure HaltTurbo;            external {MAIN/DEND/WEND};
procedure BlockMove;            external {VARH};
procedure LongMul;              external {LONG};
procedure LongDiv;              external {LONG};
procedure LongShr;              external {LONG};
procedure LongShl;              external {LONG};
procedure LongMulOvf;           external {LOVF};
procedure Overflow;             external {ERRC};
procedure SLoad;                external {STRH};
procedure SStore;               external {STRH};
procedure RangeError;           external {ERRC};
procedure SCopy;                external {STRH};
procedure SConcat;              external {STRH};
procedure SPos;                 external {STRH};
procedure SCompare;             external {STRH};
procedure SChar;                external {STRH};
procedure SPacked;              external {STRH};
procedure SInsert;              external {STRH};
procedure SDelete;              external {STRH};
procedure ZLoad;                external {SETH};
procedure ZStore;               external {SETH};
procedure ZBitMask;             external {SETH};
procedure FTrunc;               external {F87H/WE87};
procedure FRound;               external {F87H/WE87};
procedure FInt;                 external {F87H/WE87};
procedure FSqrt;                external {F87H/WE87};
procedure FSin;                 external {F87H/WE87};
procedure FCos;                 external {F87H/WE87};
procedure FArcTan;              external {F87H/WE87};
procedure FLn;                  external {F87H/WE87};
procedure FExp;                 external {F87H/WE87};
procedure NewPtr;               external {HEAP/WMEM};
procedure DisposePtr;           external {HEAP/WMEM};
procedure MarkPtr;              external {HEAP/WMEM};
procedure ReleasePtr;           external {HEAP/WMEM};
procedure GetFreMem;            external {HEAP/WMEM};
procedure GetFreMax;            external {HEAP/WMEM};
procedure ZWordLoad;            external {SETH};
procedure ZAddComp;             external {SETH};
procedure ZAddRange;            external {SETH};
procedure ZUnion;               external {SETH};
procedure ZDifference;          external {SETH};
procedure ZIntersect;           external {SETH};
procedure ZEqual;               external {SETH};
procedure ZRelation;            external {SETH};
procedure GetParCnt;            external {PARS/WPAR};
procedure GetIORes;             external {ERRC};
procedure InOutCheck;           external {ERRC};
procedure RangeCheck;           external {ERRC};
procedure StackCheck;           external {ERRC};
procedure WriteFloat;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TF87};{$ENDIF}
procedure WriteStr;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TSTR};{$ENDIF}
procedure WriteInt;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TINT};{$ENDIF}
procedure WriteBool;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TBOL};{$ENDIF}
procedure WriteChar;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCHR};{$ENDIF}
procedure WriteLine;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure WriteEnd;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure WriteFile;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure ReadFloat;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TF87};{$ENDIF}
procedure ReadStr;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TSTR};{$ENDIF}
procedure ReadInt;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TINT};{$ENDIF}
procedure ReadChar;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCHR};{$ENDIF}
procedure ReadLine;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure ReadEnd;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure ReadFile;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure InitRand;             external {RAND};
procedure AssignText;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure ResetText;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure RewriteText;          {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure CloseText;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure AssignFile;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure ResetFile;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure RewriteFile;          {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure CloseFile;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure EraseFile;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FDIR};{$ENDIF}
procedure RenameFile;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FDIR};{$ENDIF}
procedure GetSEoln;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TFUN};{$ENDIF}
procedure GetSEof;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TFUN};{$ENDIF}
procedure GetTEoln;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TFUN};{$ENDIF}
procedure GetTEof;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TFUN};{$ENDIF}
procedure ReadBlock;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure WriteBlock;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure SeekFile;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure GetFPos;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FFUN};{$ENDIF}
procedure GetFSize;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FFUN};{$ENDIF}
procedure GetFEof;              {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FFUN};{$ENDIF}
procedure FFrac;                external {F87H/WE87};
procedure UpperCase;            external {CHAR};
procedure TruncFile;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure FillMem;              external {MEMH};
procedure RandInt;              external {RAND};
procedure RandFloat;            external {RAND};
procedure GetParStr;            external {PARS/WPAR};
procedure MoveMem;              external {MEMH};
procedure StrInt;               external {SINT};
procedure ValInt;               external {SINT};
procedure StrFloat;             external {SF87};
procedure ValFloat;             external {SF87};
procedure DirGet;               external {DIRH};
procedure DirSet;               external {DIRH};
procedure DirCreate;            external {DIRH};
procedure DirRemove;            external {DIRH};
procedure AppendText;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure FlushText;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure BufferText;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure FRealExt;             external {F87H/WE87};
procedure FExtReal;             external {F87H/WE87};
procedure RAdd;                 external {F48H};
procedure RSub;                 external {F48H};
procedure RMul;                 external {F48H};
procedure RDiv;                 external {F48H};
procedure RCmp;                 external {F48H};
procedure RFloat;               external {F48H};
procedure RTrunc;               external {F48H};
procedure RRound;               external {F48H};
procedure RSqr;                 external {F48H};
procedure WriteReal;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TF48};{$ENDIF}
procedure ReadReal;             {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TF48};{$ENDIF}
procedure StrReal;              external {SF48};
procedure ValReal;              external {SF48};
procedure RInt;                 external {F48F};
procedure RFrac;                external {F48F};
procedure RSqrt;                external {F48F};
procedure RSin;                 external {F48F};
procedure RCos;                 external {F48F};
procedure RLn;                  external {F48F};
procedure RExp;                 external {F48F};
procedure RArcTan;              external {F48F};
procedure RandReal;             external {RAND};
procedure InitEM86;             external {EI86/WI87};
procedure InitEM87;             external {EI87/WI87};
procedure Construct;            external {OBJH};
procedure Destruct;             external {OBJH};
procedure CopyObject;           external {OBJH};
procedure MethodCheck;          external {OBJH};
procedure FindMethod;           external {DMTH};
procedure CallMethod;           external {DMTH};
procedure ReadPChar;            {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TPCH};{$ENDIF}
procedure WritePChar;           {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TPCH};{$ENDIF}
procedure AssignTextC;          {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {TCTL};{$ENDIF}
procedure AssignFileC;          {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FCTL};{$ENDIF}
procedure RenameFileC;          {$IFDEF NOSTDIO}Assembler;Asm mov ax,211; jmp HaltError End;{$ELSE}external {FDIR};{$ENDIF}
procedure StrIntC;              external {CINT};
procedure ValIntC;              external {CINT};
procedure StrFloatC;            external {CF87};
procedure ValFloatC;            external {CF87};
procedure StrRealC;             external {CF48};
procedure ValRealC;             external {CF48};

procedure LibEntry;             external {MAIN/DLIB/WLIB};
procedure LibExit;              external {MAIN/DLIB/WLIB};
procedure LibExitProc;          external {MAIN/DLIB/WLIB};
{$IFDEF MSDOS}
 procedure InitTask;            external {MAIN};
{$ELSE}
 procedure InitTask;            external 'KERNEL' index $005B;
{$ENDIF}

{----------------------------------------------------------------------------}
{JA TNNE KAIKKI OMAT, _EI_YHTN_AIKASEMMIN_!!!!!!!!!!}
{----------------------------------------------------------------------------}

{$IFDEF DPMI}
 procedure __AHIncr;            external 'KERNEL' index $0072;
 procedure __0000H;             external 'KERNEL' index $00C1;
 procedure __0040H;             external 'KERNEL' index $00C1;
 procedure __A000H;             external 'KERNEL' index $00AE;
 procedure __B000H;             external 'KERNEL' index $00B5;
 procedure __B800H;             external 'KERNEL' index $00B6;
 procedure MEMallocateBlock;    external 'RTM' index $0005;
 procedure MEMfreeBlock;        external 'RTM' index $0006;
 procedure MEMqueryFreeMem;     external 'RTM' index $0015;
 Function MessageBox;           external 'USER' index $0001;
{$ENDIF}
{$IFDEF Windows}
 procedure LocalInit;           external 'KERNEL' index $0004;
 procedure GlobalAlloc;         external 'KERNEL' index $000F;
 procedure GlobalFree;          external 'KERNEL' index $0011;
 procedure GlobalLock;          external 'KERNEL' index $0012;
 procedure GlobalUnlock;        external 'KERNEL' index $0013;
 procedure GlobalHandle;        external 'KERNEL' index $0015;
 procedure GlobalCompact;       external 'KERNEL' index $0019;
 procedure WaitEvent;           external 'KERNEL' index $001E;
 procedure GetModuleFileName;   external 'KERNEL' index $0031;
 procedure __AHIncr;            external 'KERNEL' index $0072;
 procedure GetWinFlags;         external 'KERNEL' index $0084;
 procedure GetFreeSpace;        external 'KERNEL' index $00A9;
 Function MessageBox;           external 'USER' index $0001;
 procedure InitApp;             external 'USER' index $0005;
 procedure __FPMath;            external 'WIN87EM' index $0001;
 procedure AnsiToOem;           external 'KEYBOARD' index $0005;
 procedure OemToAnsi;           external 'KEYBOARD' index $0006;
{$ENDIF}

Function ParmStr;       External; {PARM}
Function ParmCount;     External; {PARM}
Procedure FillWord;     External; {MEMH}
Function GetDrv;        External; {DIRH}
{$IFNDEF NoSTDIO}
 Function FSeek;        External; {FCTL}
 Function FGetCh;       External; {FCTL}
 Function FPutCh;       External; {FCTL}
{$ENDIF}
Function LoCase;        External; {CHAR}

Function Min; Begin If X>Y Then Min := Y Else Min := X End;
Function Max; Begin If X<Y Then Max := Y Else Max := X End;
Function FormatStr; external {FORMAT};

{$IFNDEF Windows}
Function Cmdline; Assembler;
Asm
  mov dx, PrefixSeg
  mov ax, 80h
End;
{$ENDIF}

Function SPFix(Var s: String): PString;
Begin
  While(s[0]>#0)And(s[Length(s)]In[' ',#0,#255])Do Dec(s[0]);
  While(s[1]In[' ',#0])And(s[0]>#0)Do Delete(s,1,1);
  SPFix := @s
End;

Procedure GetRunTimeError(Var s: String);
Var
  Args: Array[0..2]Of LongInt;
  Buf: Array[0..255]Of Char;
  w: Word;
Begin
  Args[0] := ExitCode;
  Args[1] := LongRec(ErrorAddr).Hi;
  Args[2] := LongRec(ErrorAddr).Lo;
  w := 0;
  While RunErrorMessage[w]<>#0 Do Inc(w);
  Move(RunErrorMessage^, Buf[1], w);
  Buf[0] := Chr(w);
	FormatStr(s, String(Buf), Args);
End;

Procedure StdReportError;
Var s: String;
Begin
  If(ErrorAddr=Nil)Or(ErrorAddr=Ptr($FFFF,$FFFF))Then Exit;
  GetRunTimeError(s);
  {$IFDEF Windows}
   s[Length(s)+1] := #0;
   MessageBox(0, PChar(@s)+1, Nil, $1010);
  {$ELSE}
   Asm
     push ds
      push ss
      pop ds
      lea si, s
      cld
      lodsb
      xor ah, ah
      xchg ax, cx
      mov ah, 40h
      mov bx, 1
      mov dx, si
      int 21h
     pop ds
   End;
  {$ENDIF}
End;

Procedure DoExitProcs; Near;
Var ea: Procedure;
Begin
  While @ExitProc <> Nil Do
  Begin
    ea := ExitProc;
    ExitProc := Nil;
    InOutRes := 0;
    ea
  End;
End;

Procedure SysTermGetExitAddress;
Var
  ea: Procedure;
	ax: LongInt;
  es: Word;
Begin
  @ea := ErrAddr;
  {$IFDEF MSDOS}
   If @ea<>Nil Then
   Begin
     ax := OvrLoadList;
     If ax<>0 Then
     Begin
       Repeat                              {Convert physical overlay}
         es := ax;                         {address to virtual address}
         ax := MemW[es:16]; {ovSegment}
         If(ax<>0)And(ax <= Seg(@ea))And(Seg(@ea)-ax < $1000)Then
         Begin
           ax := Ofs(@ea) + (Seg(@ea)-ax)*16;
           If ax < MemW[ovrLoadList:8] Then Break {ovCodeSize}
         End;
         ax := MemW[es:20]  {ovNext}
       Until ax=0;
       @ea := Ptr(ax, es)
     End;
     Dec(PtrRec(ea).Seg, $10+PrefixSeg)
   End;
   ErrorAddr := @ea;
  {$ENDIF}
  {$IFDEF DPMI}
   Asm
     mov bx, ErrAddr.word[2]
     verr bx
     je @@1
     mov bx, -1
     mov ErrorAddr.word[0], bx
     jmp @@2
@@1: mov es, bx
     mov bx, word ptr es:[0]
@@2: mov ErrorAddr.word[2], bx
   End;
  {$ENDIF}
End;

Procedure SysTermHandleExitProcs;
Begin
  {$IFNDEF MSDOS}
  If PrefixSeg<>0 then {When library, WEP will do exit procs}
	{$ENDIF}
    DoExitProcs;
End;

Procedure SysTermRestoreVectors; Assembler;
Asm                                   {Restore interrupt vectors}
  {$IFDEF MSDOS}
    mov si, offset SaveIntTab
    mov di, offset SaveInt00
    cld
    xor ch, ch
    lodsb
    mov cl, al
@@1:lodsb
    mov ah, 25h
    push ds
     lds dx, [di]
     int 21h
    pop ds
    add di, 4
    loop @@1
  {$ENDIF}
End;

Procedure DosTerminate; Assembler;
Asm
  mov ah, 4Ch
  mov al, byte ptr ExitCode
  int 21h
End;

Procedure StdTerminator;
Begin
  SysTermGetExitAddress;
  SysTermHandleExitProcs;
  SysTermRestoreVectors;

  If ModeX Then InLine($B8/3/0/$CD/16);

  SysTermReportError;

  DosTerminate
End;

{$IFNDEF NoSTDIO}
Function ByteFileSize(Var t): LongInt; Assembler;
Asm
	les si, t
	mov bx, es:[si]
	mov ax, 4202h
	xor cx, cx
	xor dx, dx
	int 21h
	push ax
	 push dx
		mov ax, 4200h
		xor cx, cx
		xor dx, dx
		int 21h
	 pop dx
	pop ax
End;

Var OldExit: Procedure;
Procedure NewExit; Far;
Begin
	ExitProc := OldExit;
	Close(Output);
	Close(Input)
End;
{$ENDIF}

Begin
{$IFNDEF NoSTDIO}
	Assign(Output, ''); ReWrite(Output);
	Assign(Input, ''); Reset(Input);
	OldExit := ExitProc;
	ExitProc := NewExit;
{$ENDIF}
End.
