        TITLE   MAIN

.8086

        INCLUDE SE.ASM

DATA    SEGMENT WORD PUBLIC

        extrn   ErrorFName:dword,ExitCode:word,ErrorAddr:dword
        extrn   ErrAddr:dword,OldDS:word,OldBP:word

        extrn   ErrorMsgBuf:byte

DATA    ENDS

CODE    SEGMENT BYTE PUBLIC

        ASSUME cs:CODE,ds:DATA,es:nothing

        public ReportError

; Error strings
FileNotFound    db 'File not found: ',0
PathNotFound    db 'Path not found',0
AccessDenied    db 'File access denied',0
CantRead        db 'Can''t read from ',0
CantWrite       db '(Insufficient disk space?)',13,10,'Can''t write to ',0
UserError       db 'Wanted numbers, got something else',0
WriteProtect    db 'Disk is write protected',0
DivideError     db 'Divide by zero or divide overflow',0
OutOfMemory     db 'Out of memory',0
OutOfStack      db 'Stack overflow',0
InvalidFloat    db 'Floating point over/underflow/misuse',0
OverlayError    db 'Overlay file error or',13,10,'overlay manager not installed',0
ProtectionError db 'Either INT 06, 0C, 0D or 0E',13,10
                db 'detected. General reason may be a',13,10
                db 'brainless mix of the RETN and RETF',13,10
                db 'instructions of x86 processor.',13,10
                db 'Another common fault is stack overflow.',13,10
                db 'Also very often JMP [BX] instruction',13,10
                db 'can cause one of these interrupts, if',13,10
                db 'some kind of multitasking system has',13,10
                db 'modified the value of BX',0

OtherError      db 'Runtime error ',0

LoppuStr0       db '.',13,10,0
LoppuStr1       db 'SS=',0
LoppuStr2       db '  SP=',0
LoppuStr3       db '    CS=',0
LoppuStr4       db '  IP=',0
LoppuStr5       db 13,10,'DS=',0
LoppuStr6       db '  BP=',0
LoppuStr7       db '     Virtual CS=',0
ReportMe        db 13,10,'Let the coders by The Crimson Stream',13,10
                db 'get this message.',13,10,0

; Add string to other string
; In     CS:BX = pointer to sourcestring
; In/Out DS:DI = offset of destination string

AddToConst:
@@2:    mov al, cs:[bx]
        or al, al
        jz @@1
        segds stosb
        inc bx
        jmp short @@2
@@1:    ret

; Add decimal to string
; In    AX = Number
;       DS:DI = offset of destination string
Dec2Str:xor dx, dx
        mov cx, 100
        div cx
        add al, '0'
        push cs
        call near ptr Chr2Str
        mov ax, dx
        aam
        xchg al, ah
        add ax, '00'
        segds stosw
        retf

        public Long2Str,Hex2Str,Byt2Str,Nib2Str,Chr2Str

; Add hex to string
; In    DX:AX = Number
;       DS:DI = offset of destination string
Long2Str:push ax
         mov ax, dx
         push cs
         call near ptr Hex2Str
        pop ax
Hex2Str:push ax
         xchg ah, al
         push cs
         call near ptr Byt2Str
        pop ax
Byt2Str:aam 16
        xchg ah, al
        push cs
        call near ptr Nib2Str
        xchg ah, al
Nib2Str:add al, '0'
        cmp al, '9'
        jbe Chr2Str
        add al, 'A'-'0'-10
Chr2Str:segds stosb
        retf

ReportError:
        mov al, 34h
        out 43h, al
        xor al, al
        out 40h, al
        out 40h, al
        cld
        ;mov ax, seg DATA
        ;mov ds, ax
        mov di, offset ErrorMsgBuf
        mov ax, ExitCode
        cmp ax, 2
        je @@A2
        cmp ax, 3
        je @@A3
        cmp ax, 5
        je @@A5
        cmp ax, 100
        je @@A100
        cmp ax, 101
        je @@A101
        cmp ax, 106
        je @@A106
        cmp ax, 150
        je @@A150
        cmp ax, 200
        je @@A200
        cmp ax, 202
        je @@A202
        cmp ax, 203
        je @@A203
        cmp ax, 205
        jb @@BUU
        cmp ax, 207
        jbe @@A205
        cmp ax, 210
        jb @@A208
        cmp ax, 216
        je @@A216
        jmp short @@BUU
@@A2:   mov bx, offset FileNotFound
@@B7:   call AddToConst
        push ds
         lds si, ErrorFName
@@B5:    lodsb
         or al,al
         jz @@B6
         push cs
         call near ptr Chr2Str
         jmp short @@B5
@@B6:   pop ds
        jmp short @@B4
@@A3:   mov bx, offset PathNotFound
        jmp short @@B2
@@A5:   mov bx, offset AccessDenied
        jmp short @@B2
@@A100: mov bx, offset CantRead
        jmp short @@B7
@@A101: mov bx, offset CantWrite
        jmp short @@B7
@@A106: mov bx, offset UserError
        jmp short @@B2
@@A150: mov bx, offset WriteProtect
        jmp short @@B2
@@A200: mov bx, offset DivideError
        jmp short @@B2
@@A202: mov bx, offset OutOfStack
        jmp short @@B2
@@A203: mov bx, offset OutOfMemory
        jmp short @@B2
@@A205: mov bx, offset InvalidFloat
        jmp short @@B2
@@A208: mov bx, offset OverlayError
        jmp short @@B2
@@BUU:  mov bx, offset OtherError
        call AddToConst
        mov ax, ExitCode
        push cs
        call near ptr Dec2Str
        jmp short @@B4
@@A216: mov bx, offset ProtectionError
@@B2:   call AddToConst
@@B4:   mov bx, offset LoppuStr0
        call AddToConst
        cmp ExitCode, 200
        jb @@1
        mov bx, offset LoppuStr1
        call AddToConst
        mov ax, ss
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr2
        call AddToConst
        mov ax, sp
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr3
        call AddToConst
        mov ax, ErrAddr.seg
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr4
        call AddToConst
        mov ax, ErrAddr.ofs
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr5
        call AddToConst
        mov ax, OldDS
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr6
        call AddToConst
        mov ax, OldBP
        push cs
        call near ptr Hex2Str
        mov bx, offset LoppuStr7
        call AddToConst
        mov ax, ErrorAddr.seg
        push cs
        call near ptr Hex2Str
        mov bx, offset ReportMe
        call AddToConst
@@1:    mov bx, offset ErrorMsgBuf
        xor al, al
        segds stosb
        retn

CODE    ENDS

        END
